function [matcharr rule] = match(x)
[N D] = size(x);
M = 3^D;
rule = changebase(0:(M-1),3,D);
matcharr = zeros(N,M);
wt = ones(M,1);
for i = 1:M
    wt(i) = 2^(-length(find(rule(i,:) == 2))); 
end;
for i = 1:N
    for j = 1:M
        r = rule(j,:);
        ind2 = find(rule(j,:) == 2);
        r(ind2) = x(i,ind2);
        if (all(r == x(i,:)))
            matcharr(i,j) = wt(j);
        end;
    end;
end;